/**
 * Created by frank on 02/09/17.
 */


Components.utils.import("resource://gre/modules/AddonManager.jsm");

jsinclude(["chrome://cardbook/content/preferences/cardbookPreferences.js"]);
jsinclude(["chrome://cardbook/content/cardbookSynchronization.js"]);

jsinclude(["chrome://cardbook/content/addressbooksconfiguration/wdw_addressbooksAdd.js"]);
jsinclude(["chrome://cardbook/content/cardbookWebDAV.js"]);

jsinclude(["chrome://cardbook/content/cardbookNotifications.js"]);

jsinclude(["chrome://cardbook/content/ovl_cardbook.js"]);


RubricaWebreq=
    {

        checkCardBook:function() //controlla se CardBook è installato o meno
        {

            var trovato=false; //status di cardbook (false = non esiste true = esiste)
            var name=null; //nome del componente aggiuntivo preso in esame


            AddonManager.getAllAddons(function(aAddons) //funzione che prende tutti gli addon nella lista di thunderbird
            {

                aAddons.forEach(function(aAddon)
                {


                    name=aAddon.name.toString();

                    if(name =="CardBook")
                        trovato=true; //quindi cardbook è installato


                })



                //cardbook non è installato su thunderbird allora di seguito la procedura di installazione
                if(trovato==false)
                {


                    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
                    var confirm=promptService.alert(null,"Webreq Mailboard","Per il corretto funzionamento della rubrica bisogna installare Cardbook");



                }
                else
                {

                    ovl_cardbook.open();
                    return true; //quindi cardbook è installato su thunderbird
                }


            });

        },
        downloadServerCredentials:function()
        {

            let request = new XMLHttpRequest();
            AccessToken=ClassCredential.getAccessToken();

            //myDump(AccessToken);

            request.onreadystatechange = function () {
                if (request.readyState == 4 && request.status == '200') {
                    let response = JSON.parse(request.responseText);
                    fn(response);

                    //      myDump(response);
                    return response;
                }
            };
            request.open("GET","http://webreq.space" + "/api/getAddressbooks?access_token=" + AccessToken, true);//accesso alla api getImaps
            request.send();


        },
        setListAddress:function()
        {


            var adirPrefId,connection,params=null;

            wdw_addressbooksAdd.gCardDAVURLs.push([definitiveURL, false]); // [url, discovery]
            wdw_addressbooksAdd.gCardDAVURLs.push([cardbookSynchronization.getWellKnownUrl(definitiveURL), true]);



            adirPrefId = cardbookUtils.getUUID();
            connection = {connUser: username, connPrefId: adirPrefId, connUrl: wdw_addressbooksAdd.gCardDAVURLs[0][0], connDescription: wdw_addressbooksAdd.gValidateDescription};
            params = {aPrefIdType: "CARDDAV"};


            var carddavURL = cardbookSynchronization.getCardDAVUrl(definitiveURL, username);
            wdw_addressbooksAdd.gCardDAVURLs.push([carddavURL, false]);

            cardbookSynchronization.initDiscovery(adirPrefId);

            cardbookPreferences.setId(adirPrefId, adirPrefId);
            cardbookPreferences.setUrl(adirPrefId, wdw_addressbooksAdd.gCardDAVURLs[0][0]);




            cardbookNotifications.setNotification("resultNotifications", "ValidatingLabel", wdw_addressbooksAdd.gCardDAVURLs[0][0], "PRIORITY_INFO_MEDIUM");
            cardbookSynchronization.initMultipleOperations(adirPrefId);
            cardbookRepository.cardbookServerValidation[adirPrefId] = {length: 0, user: aUsername};
            cardbookRepository.cardbookServerSyncRequest[adirPrefId]++;
            wdw_addressbooksAdd.gRunningDirPrefId = adirPrefId;


            if (wdw_addressbooksAdd.gCardDAVURLs[0][1])
            {
                cardbookSynchronization.discoverPhase1(connection, "GETDISPLAYNAME", params);
            } else {
                cardbookSynchronization.validateWithoutDiscovery(connection, "GETDISPLAYNAME", params);
            }
            wdw_addressbooksAdd.waitForDiscoveryFinished(adirPrefId, username, "informatico2", "CARDDAV");

            /*

             response=RubricaWebreq.downloadServerCredentials();

             for(i=0;i<response.lenght;i++)
             {





             }



             var connection = {connUser: username, connPrefId: "", connPrefIdType: "", connUrl: aUrl, connDescription: wdw_addressbooksAdd.gValidateDescription};
             cardbookSynchronization.discoverPhase1(connection, "GETDISPLAYNAME");
             wdw_addressbooksAdd.waitForDiscoveryFinished(aDirPrefId, aUrl, aUsername, aPassword);

             */

        },
        downloadContacts:function() //funzione che scarica i contatti dalla rubriche memorizzate su webreq
        {

            today_date=new Date(); //data oggi
            today_date_seconds=today_date.getTime()/1000; //data unix time convertita in secondi

            dead_line=getDate();//ricavo termine scadenza del cookie

//3 volte *60 *24= giorni
// data login + timestamp


            if(ClassCredential.exists() && dead_line!=null)
            {

                if(parseFloat(today_date_seconds)< parseFloat(dead_line.expire_in))
                {


                    WizardArg = {action: "fist",  serverCallback: wdw_cardbook.createAddressbook}; //argomenti per il wizard di cardbook

                    // questo link viene usato per test su space ma deve essere passato dalla procedura di autenticazione allo stesso modo di come passano gli account email

                    URL=WEBREQ_CARDDAV_URL;
//            URL_prova="http://contacts.webreq.space/server/addressbooks/Informatico";

                    username=RubricaWebreq.findUsername();
                    password=ClassCredential.getPassword();


                    definitiveURL=URL+username;
                    //definitiveURL_prova=URL_prova;

                    var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
                    var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",Components.interfaces.nsILoginInfo,"init");



                    if(username==null) //controllo se  si è effettuato il login da componente (username = null => che non si è effettuato il login)
                    {

                        myAlert("Per poter usare questa funzionalità bisogna connettersi a webreq");

                        return false;

                    }


                    mywin=window.openDialog("chrome://cardbook/content/addressbooksconfiguration/wdw_addressbooksAdd.xul", "", "resizable,chrome",WizardArg); //finestra aggiungi rubrica di cardbook
                    window.mywin.document.title=WEBREQ_VERSION.toString();


                    window.setTimeout(function()
                    {


                        //window.mywin.document.getElementById('addressbook-wizard').goto('searchPage');
                        window.mywin.document.getElementById('addressbook-wizard').goTo("remotePage"); //pagina delle rubriche remote di cardbook
                        //password=DownloadCredential();


                    },500);
                    window.clearTimeout(500);



                    window.setTimeout(function()
                    {


                        window.mywin.document.getElementsByTagName("radio")[9].setAttribute("selected","false");

                        radio_group=window.mywin.document.getElementById("remotePageType");
                        webreq_radio=window.mywin.document.createElement("radio");


                        webreq_radio.setAttribute("label","Webreq");
                        webreq_radio.setAttribute("group","remotePageType");
                        webreq_radio.setAttribute("selected","true");


                        webreq_radio.addEventListener("onclick",function(){

                            window.mywin.document.getElementById('remotePageURI').value=definitiveURL.toString(); //campo URL della pagina rubrica remota di CardBook

                            //   window.mywin.document.getElementById('remotePageUsername').value="Informatico";
                            window.mywin.document.getElementById('remotePageUsername').value=username; //campo Username della pagina rubrica remota di Cardbook
                            window.mywin.document.getElementById('remotePagePassword').disabled=true; //campo password della pagina rubrica remota di Cardbook

//                    RubricaWebreq.downloadServerCredentials();

                            window.mywin.document.getElementById('validateButton').disabled=false; //tasto di conferma abilitato


                        });

                        radio_group.appendChild(webreq_radio);

                        window.mywin.document.getElementById('remotePageURI').value=definitiveURL.toString(); //campo URL della pagina rubrica remota di CardBook


                        window.mywin.document.getElementById('remotePageUsername').value=username; //campo Username della pagina rubrica remota di Cardbook
                        window.mywin.document.getElementById('remotePagePassword').disabled=true; //campo password della pagina rubrica remota di Cardbook
                        window.mywin.document.getElementById('remotePagePassword').value=password;


                        window.mywin.document.getElementById('validateButton').disabled=false; //tasto di conferma abilitato
                        window.mywin.document.getElementById('validateButton').click(); //click sul bottone simulato



                    },2000);
                    window.clearTimeout(2000);



                    window.setTimeout(function()
                    {

                        window.mywin.document.getElementById('addressbook-wizard').canAdvance=true;
                        window.mywin.document.getElementById('addressbook-wizard').advance();



                    },6000);
                    window.clearTimeout(6000);

                }
                else
                connectionProcedureInit();


            }
            else
            connectionProcedureInit();


        }
        ,
        findUsername:function()
        {

            Components.utils.import("resource://gre/modules/FileUtils.jsm");
            let file = FileUtils.getFile("ProfD", ["webreqSession.txt"]);

            if(file.exists())
            {
                let istream = Components.classes["@mozilla.org/network/file-input-stream;1"].

                createInstance(Components.interfaces.nsIFileInputStream);
                istream.init(file, 0x01, 0444, 0);
                istream.QueryInterface(Components.interfaces.nsILineInputStream);

                let line = {}, lines = [], hasmore;
                do
                {

                    hasmore = istream.readLine(line);
                    lines.push(line.value);

                } while(hasmore);

                istream.close();
                let credential = JSON.parse(lines);
                return credential.info.username;
            }
            else{
                return null;
            }

        },
        OAuth2Webreq:function()
        {

            //myDump("mi collego a webreq");



        },
        TabAddons:function() //funzione per la gestione degli addon da codice
        {


            let url = "about:addons"; //url in cui ci sono gli addons
            let tabmail = document.getElementById("tabmail"); //id della tab di thunderbird

            if (!tabmail)
            {
                // Try opening new tabs in an existing 3pane window
                let mail3PaneWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                    .getService(Components.interfaces.nsIWindowMediator)
                    .getMostRecentWindow("mail:3pane");

                if (mail3PaneWindow)
                {
                    tabmail = mail3PaneWindow.document.getElementById("tabmail");
                    mail3PaneWindow.focus(); //prendo il focus sul contenuto della tab
                }

            }

            if (tabmail)
                tabmail.openTab("contentTab", {contentPage: url});
            else
                window.openDialog("chrome://messenger/content/", "_blank",
                    "chrome,dialog=no,all", null,
                    { tabType: "contentTab",
                        tabParams: {contentPage: url} });


        }



    };

